var windowFocus = true;
var username;
var chatHeartbeatCount = 0;
var minChatHeartbeat = 1000;
var maxChatHeartbeat = 33000;
var chatHeartbeatTime = minChatHeartbeat;
var originalTitle;
var blinkOrder = 0;

var chatboxFocus = new Array();
var newMessages = new Array();
var newMessagesWin = new Array();
var chatBoxes = new Array();
var emoticonImg;

jQuery(document).ready(function(){
  originalTitle = document.title;
  startChatSession();

  jQuery([window, document]).blur(function(){
    windowFocus = false;
  }).focus(function(){
    windowFocus = true;
    document.title = originalTitle;
  });

  jQuery('.google_chat_emoticons_rise').live('click', function(e){
    jQuery('div.google_chat_emoticons').css('display', 'none').removeClass('google_chat_emoticons_active');
    jQuery(this).children("div").css('display', 'block').addClass('google_chat_emoticons_active');
  });
  jQuery('.google_chat_emoticons_active ul.J-KX-KY li').live('click', function(e){
    var currLI = jQuery(this);
    currLI.addClass('J-KX-KU-KO').siblings().removeClass('J-KX-KU-KO');
    currLI.parents().parents().find('.J-KX-Jv table').eq(currLI.index()).show().siblings().hide();
  });
  jQuery('body').live('click', function(e){
    var clickedParent = jQuery(e.target).parent();
    if(jQuery(e.target).attr('class') != 'google_chat_emoticons_rise' && !clickedParent.hasClass("google_chat_emoticons") && !clickedParent.hasClass("J-KX-KU-KO") && !clickedParent.hasClass("J-KX-KY") && !clickedParent.hasClass("NQLkBe")) {
      jQuery('.google_chat_emoticons').hide().removeClass('google_chat_emoticons_active');
    }
  });
  jQuery('.J-JX-KA td').live('click', function(e){
    var currEle = jQuery(this);
    if(currEle.hasClass('J-JX-KA-JY')) {
      emoticonImg = currEle.children('div').attr('class');
    }
    else {
      emoticonImg = currEle.attr('class');
    }

    var selectedTxtArea = jQuery('.chatboxtextareaselected');
    switch (emoticonImg) {
      case 'k7':
      case 'k9':
      case 'k8':
      case 'k6':
        selectedTxtArea.val(selectedTxtArea.val() + " :) ");
        break;

      case 'j6':
      case 'j8':
      case 'j7':
      case 'j5':
        selectedTxtArea.val(selectedTxtArea.val() + " :D ");
        break;

      case 'lv':
      case 'lx':
      case 'lw':
      case 'lu':
        selectedTxtArea.val(selectedTxtArea.val() + " ;)");
        break;

      case 'jj':
      case 'jl':
      case 'jk':
      case 'ji':
        selectedTxtArea.val(selectedTxtArea.val() + " :'( ");
        break;

      case 'kZ':
      case 'k1':
      case 'k0':
      case 'kY':
        selectedTxtArea.val(selectedTxtArea.val() + " :-o ");
        break;

      case 'k3':
      case 'k5':
      case 'k4':
      case 'k2':
        selectedTxtArea.val(selectedTxtArea.val() + " :-/ ");
        break;

      case 'i0':
      case 'i2':
      case 'i1':
      case 'iZ':
        selectedTxtArea.val(selectedTxtArea.val() + " x-( ");
        break;

      case 'j2':
      case 'j4':
      case 'j3':
      case 'j1':
        selectedTxtArea.val(selectedTxtArea.val() + " :( ");
        break;

      case 'jf':
      case 'jh':
      case 'jg':
      case 'je':
        selectedTxtArea.val(selectedTxtArea.val() + " B-) ");
        break;

      case 'lr':
      case 'lt':
      case 'ls':
      case 'lq':
        selectedTxtArea.val(selectedTxtArea.val() + " :P ");
        break;

      case 'ka':
      case 'kc':
      case 'kb':
      case 'j9':
        selectedTxtArea.val(selectedTxtArea.val() + " <3 ");
        break;

      case 'lb':
      case 'ld':
      case 'lc':
      case 'la':
        selectedTxtArea.val(selectedTxtArea.val() + " :-| ");
        break;

    }
  });

  jQuery('#googlechat .status_indicator').live('click, hover', function(){
    jQuery('#googlechat .googlechat_notification_sound_panel').hide();
    jQuery('#googlechat .status_indicator_panel').show();
  });
  jQuery('#googlechat .googlechat_setting_wrapper').live('click, hover', function(){
    jQuery('#googlechat .status_indicator_panel').hide();
    jQuery('#googlechat .googlechat_notification_sound_panel').show();
  });
  jQuery('body').live('click', function(e){
    var clickedParent = jQuery(e.target).parent();
    if(!clickedParent.hasClass("googlechat_subpanel_title") && !clickedParent.hasClass("status_indicator")) {
      jQuery('#googlechat .status_indicator_panel').hide();
    }
    if(!clickedParent.hasClass("sound_on") && !clickedParent.hasClass("sound_off")) {
      jQuery('#googlechat .googlechat_notification_sound_panel').hide();
    }
  });
  //googlechat panel status setting
  jQuery('#googlechat .status_indicator_panel ul li').live('click', function(){
    var newStatus;
    var $this = jQuery(this);
    if ($this.index() == 0) {
      newStatus = 1;
    }
    else if ($this.index() == 1) {
      newStatus = 2;
    }
    else if ($this.index() == 2) {
      newStatus = 4;
    }
    jQuery.post(Drupal.settings.googlechat.statusUrl, {status: newStatus}, function(data){
      jQuery('#googlechat .status_indicator img:first-child').attr('class', 'googlechatstatus_' + newStatus);
    });
  });
  //googlechat panel notification sound on/off
  jQuery('#googlechat .googlechat_notification_sound_panel ul li').live('click', function(){
    var $this = jQuery(this);
    if ($this.hasClass('sound_on')) {
      jQuery.post(Drupal.settings.googlechat.changeSoundStatusURL, {sound_status: 1}, function(data){
        Drupal.settings.googlechat.userNotificationSound = data;
      });
    }
    else {
      jQuery.post(Drupal.settings.googlechat.changeSoundStatusURL, {sound_status: 2}, function(data){
        Drupal.settings.googlechat.userNotificationSound = data;
      });
    }
    jQuery('#googlechat .googlechat_notification_sound_panel').hide();
    $this.find('span').addClass('googlechat-icon-check').removeClass('clear_background_image');
    $this.siblings().find('span').addClass('clear_background_image').removeClass('googlechat-icon-check');
  });
  // googlechat panel minimize and maximize
  jQuery('#googlechat .googlechat_titlebar_min').live('click', function(){
    var $this = jQuery(this);
    if($this.find('span').hasClass('googlechat-icon-minus')) {
      $this.find('span').removeClass('googlechat-icon-minus').addClass('googlechat-icon-newwin');
      jQuery('#googlechatbuddylist').hide();
      jQuery.cookie('googlechat_panel', 'no');
    }
    else {
      $this.find('span').addClass('googlechat-icon-minus').removeClass('googlechat-icon-newwin');
      jQuery('#googlechatbuddylist').show();
      jQuery.cookie('googlechat_panel', 'yes');
    }
  });
  if (jQuery.cookie('googlechat_panel') === 'no') {
    jQuery('#googlechatbuddylist').css('display', 'none');
    jQuery('#googlechat .googlechat_titlebar_min').find('span').removeClass('googlechat-icon-minus').addClass('googlechat-icon-newwin');
  }
  else {
    jQuery('#googlechatbuddylist').css('display', 'block');
    jQuery('#googlechat .googlechat_titlebar_min').find('span').addClass('googlechat-icon-minus').removeClass('googlechat-icon-newwin');
  }
});

function restructureChatBoxes() {
  align = 0;
  for (x in chatBoxes) {
    chatboxtitle = chatBoxes[x];

    if (jQuery("#chatbox_" + chatboxtitle).css('display') != 'none') {
      if (align == 0) {
        jQuery("#chatbox_" + chatboxtitle).css('right', '178px');
      } else {
        width = (align) * (225 + 7) + 178;
        jQuery("#chatbox_" + chatboxtitle).css('right', width + 'px');
      }
      align++;
    }
  }
}

function chatWith(chatuser) {
  createChatBox(chatuser);
  jQuery("#chatbox_" + chatuser + " .chatboxtextarea").focus();
}

function createChatBox(chatboxtitle, minimizeChatBox) {
  if (jQuery("#chatbox_" + chatboxtitle).length > 0) {
    if (jQuery("#chatbox_" + chatboxtitle).css('display') == 'none') {
      jQuery("#chatbox_" + chatboxtitle).css('display','block');
      restructureChatBoxes();
    }
    jQuery("#chatbox_" + chatboxtitle + " .chatboxtextarea").focus();
    return;
  }
  var emoticonsHtml = '<div class="google_chat_emoticons" style="position:absolute;right: 2px; bottom: 0px;display:none;"><div class="J-KX J-KX-K9 NQLkBe"><ul class="J-KX-KY" tabindex="0"><li class="J-KX-KU-KO"><div class="lg"></div></li><li><div class="lh"></div></li><li><div class="li"></div></li><li><div class="lj"></div></li></ul><div class="J-KX-Zf"></div><div class="J-KX-Jv"><table class="J-JX-KA" tabindex="0" cellpadding="0" style=""><tbody><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="k7" id=":35t.ic0" index="0"></div></td><td class="J-JX-KA-JY"><div class="j6" id=":35t.ic1" index="1"></div></td><td class="J-JX-KA-JY"><div class="lv" id=":35t.ic2" index="2"></div></td><td class="J-JX-KA-JY"><div class="jj" id=":35t.ic3" index="3"></div></td></tr><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY J-JX-KA-JU"><div class="kZ" id=":35t.ic4" index="4"></div></td><td class="J-JX-KA-JY"><div class="k3" id=":35t.ic5" index="5"></div></td><td class="J-JX-KA-JY"><div class="i0" id=":35t.ic6" index="6"></div></td><td class="J-JX-KA-JY"><div class="j2" id=":35t.ic7" index="7"></div></td></tr><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="jf" id=":35t.ic8" index="8"></div></td><td class="J-JX-KA-JY"><div class="lr" id=":35t.ic9" index="9"></div></td><td class="J-JX-KA-JY"><div class="ka" id=":35t.ic10" index="10"></div></td><td class="J-JX-KA-JY"><div class="lb" id=":35t.ic11" index="11"></div></td></tr></tbody></table><table class="J-JX-KA" tabindex="0" cellpadding="0" style="display: none;"><tbody><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="k9" id=":35u.ic0" index="0"></div></td><td class="J-JX-KA-JY"><div class="j8" id=":35u.ic1" index="1"></div></td><td class="J-JX-KA-JY"><div class="lx" id=":35u.ic2" index="2"></div></td><td class="J-JX-KA-JY"><div class="jl" id=":35u.ic3" index="3"></div></td></tr><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="k1" id=":35u.ic4" index="4"></div></td><td class="J-JX-KA-JY"><div class="k5" id=":35u.ic5" index="5"></div></td><td class="J-JX-KA-JY"><div class="i2" id=":35u.ic6" index="6"></div></td><td class="J-JX-KA-JY"><div class="j4" id=":35u.ic7" index="7"></div></td></tr><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="jh" id=":35u.ic8" index="8"></div></td><td class="J-JX-KA-JY"><div class="lt" id=":35u.ic9" index="9"></div></td><td class="J-JX-KA-JY"><div class="kc" id=":35u.ic10" index="10"></div></td><td class="J-JX-KA-JY"><div class="ld" id=":35u.ic11" index="11"></div></td></tr></tbody></table><table class="J-JX-KA" tabindex="0" cellpadding="0" style="display: none;"><tbody><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="k8" id=":35v.ic0" index="0"></div></td><td class="J-JX-KA-JY J-JX-KA-JU"><div class="j7" id=":35v.ic1" index="1"></div></td><td class="J-JX-KA-JY"><div class="lw" id=":35v.ic2" index="2"></div></td><td class="J-JX-KA-JY"><div class="jk" id=":35v.ic3" index="3"></div></td></tr><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="k0" id=":35v.ic4" index="4"></div></td><td class="J-JX-KA-JY"><div class="k4" id=":35v.ic5" index="5"></div></td><td class="J-JX-KA-JY"><div class="i1" id=":35v.ic6" index="6"></div></td><td class="J-JX-KA-JY"><div class="j3" id=":35v.ic7" index="7"></div></td></tr><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="jg" id=":35v.ic8" index="8"></div></td><td class="J-JX-KA-JY"><div class="ls" id=":35v.ic9" index="9"></div></td><td class="J-JX-KA-JY"><div class="kb" id=":35v.ic10" index="10"></div></td><td class="J-JX-KA-JY"><div class="lc" id=":35v.ic11" index="11"></div></td></tr></tbody></table><table class="J-JX-KA" tabindex="0" cellpadding="0" style="display: none;"><tbody><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="k6" id=":35w.ic0" index="0"></div></td><td class="J-JX-KA-JY"><div class="j5" id=":35w.ic1" index="1"></div></td><td class="J-JX-KA-JY"><div class="lu" id=":35w.ic2" index="2"></div></td><td class="J-JX-KA-JY"><div class="ji" id=":35w.ic3" index="3"></div></td></tr><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="kY" id=":35w.ic4" index="4"></div></td><td class="J-JX-KA-JY"><div class="k2" id=":35w.ic5" index="5"></div></td><td class="J-JX-KA-JY"><div class="iZ" id=":35w.ic6" index="6"></div></td><td class="J-JX-KA-JY"><div class="j1" id=":35w.ic7" index="7"></div></td></tr><tr class="J-JX-KA-axF"><td class="J-JX-KA-JY"><div class="je" id=":35w.ic8" index="8"></div></td><td class="J-JX-KA-JY"><div class="lq" id=":35w.ic9" index="9"></div></td><td class="J-JX-KA-JY"><div class="j9" id=":35w.ic10" index="10"></div></td><td class="J-JX-KA-JY"><div class="la" id=":35w.ic11" index="11"></div></td></tr></tbody></table></div></div></div>';
  jQuery(" <div />").attr("id","chatbox_" + chatboxtitle)
  .addClass("chatbox")
  .html('<div class="chatboxhead"><div class="chatboxtitle"><img src="' + Drupal.settings.googlechat.emoticonsURL + '" class="" /> ' + chatboxtitle + '</div><div class="chatboxoptions"><a href="javascript:void(0)" onclick="javascript:toggleChatBoxGrowth(\'' + chatboxtitle + '\')">-</a> <a href="javascript:void(0)" onclick="javascript:closeChatBox(\'' + chatboxtitle + '\')">X</a></div><br clear="all"/></div><div class="chatboxcontent"></div><div class="googlechat_chatboxalert"></div><div class="chatboxinput"><div class="google_chat_emoticons_rise">' + emoticonsHtml + '</div><textarea class="chatboxtextarea" onkeydown="javascript:return checkChatBoxInputKey(event,this,\'' + chatboxtitle + '\');"></textarea></div>')
  .appendTo(jQuery("body"));

  jQuery("#chatbox_" + chatboxtitle).css('bottom', '0px');

  chatBoxeslength = 0;

  for (x in chatBoxes) {
    if (jQuery("#chatbox_" + chatBoxes[x]).css('display') != 'none') {
      chatBoxeslength++;
    }
  }

  if (chatBoxeslength == 0) {
    jQuery("#chatbox_" + chatboxtitle).css('right', '178px');
  } else {
    width = (chatBoxeslength) * (225 + 7) + 178;
    jQuery("#chatbox_" + chatboxtitle).css('right', width + 'px');
  }

  chatBoxes.push(chatboxtitle);

  if (minimizeChatBox == 1) {
    minimizedChatBoxes = new Array();

    if (jQuery.cookie('chatbox_minimized')) {
      minimizedChatBoxes = jQuery.cookie('chatbox_minimized').split(/\|/);
    }
    minimize = 0;
    for (j = 0; j < minimizedChatBoxes.length; j++) {
      if (minimizedChatBoxes[j] == chatboxtitle) {
        minimize = 1;
      }
    }

    if (minimize == 1) {
      jQuery('#chatbox_' + chatboxtitle + ' .chatboxcontent').css('display','none');
      jQuery('#chatbox_' + chatboxtitle + ' .chatboxinput').css('display','none');
    }
  }

  chatboxFocus[chatboxtitle] = false;

  jQuery("#chatbox_" + chatboxtitle + " .chatboxtextarea").blur(function(){
    chatboxFocus[chatboxtitle] = false;
    jQuery("#chatbox_" + chatboxtitle + " .chatboxtextarea").removeClass('chatboxtextareaselected');
  }).focus(function(){
    chatboxFocus[chatboxtitle] = true;
    newMessages[chatboxtitle] = false;
    jQuery('#chatbox_' + chatboxtitle + ' .chatboxhead').removeClass('chatboxblink');
    jQuery("#chatbox_" + chatboxtitle + " .chatboxtextarea").addClass('chatboxtextareaselected');
  });

  jQuery("#chatbox_" + chatboxtitle).click(function() {
    if (jQuery('#chatbox_' + chatboxtitle + ' .chatboxcontent').css('display') != 'none') {
      jQuery("#chatbox_" + chatboxtitle + " .chatboxtextarea").focus();
    }
  });

  jQuery("#chatbox_" + chatboxtitle).show();
}


function chatHeartbeat(){

  var itemsfound = 0;
  if (windowFocus == false) {

    var blinkNumber = 0;
    var titleChanged = 0;
    for (x in newMessagesWin) {
      if (newMessagesWin[x] == true) {
        ++blinkNumber;
        if (blinkNumber >= blinkOrder) {
          document.title = x + ' says...';
          titleChanged = 1;
          break;
        }
      }
    }

    if (titleChanged == 0) {
      document.title = originalTitle;
      blinkOrder = 0;
    } else {
      ++blinkOrder;
    }

  } else {
    for (x in newMessagesWin) {
      newMessagesWin[x] = false;
    }
  }

  for (x in newMessages) {
    if (newMessages[x] == true) {
      if (chatboxFocus[x] == false) {
        //FIXME: add toggle all or none policy, otherwise it looks funny
        jQuery('#chatbox_' + x + ' .chatboxhead').toggleClass('chatboxblink');
      }
    }
  }
  // google chat heartbeat
  jQuery.ajax({
    url: Drupal.settings.googlechat.chatHeartBeatUrl,
    cache: false,
    dataType: "json",
    success: function(data) {

      jQuery.each(data.items, function(i, item){
        if (item != '{' && item != '}' && item.f != '') { /* fix strange ie bug*/

          chatboxtitle = item.f;

          if (jQuery("#chatbox_" + chatboxtitle).length <= 0) {
            createChatBox(chatboxtitle);
          }
          if (jQuery("#chatbox_" + chatboxtitle).css('display') == 'none') {
            jQuery("#chatbox_" + chatboxtitle).css('display','block');
            restructureChatBoxes();
          }

          if (item.s == 1) {
            item.f = username;
          }

          msg = item.m.replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&quot;/g,"\"");
          if (item.s == 2) {
            jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxinfo">' + msg + '</span></div>');
          } else {
            newMessages[chatboxtitle] = true;
            newMessagesWin[chatboxtitle] = true;
            jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent").append('<div class="chatboxmessage"><div class="chatboxuserimage"><img src="' + item.p + '" alt="' + item.f + '" width="30"/></div><div class="chatboxusercontent"><span class="chatboxmessagefrom">' + item.f + ':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">' + msg + '</span></div></div>');
            // Play new message sound effect
            if (Drupal.settings.googlechat.notificationSound == 1 && Drupal.settings.googlechat.userNotificationSound == 1) {
              jQuery("#chatbox_" + chatboxtitle).append('<div id="googlechatbeep_wrapper_' + chatboxtitle + '" style="width: 0px; height: 0px; overflow: hidden;"><embed width="0" height="0" src="' + Drupal.settings.googlechat.sound + '" id="googlechatbeep" type="application/x-shockwave-flash"></div>');
              setTimeout(function () {jQuery('#googlechatbeep_wrapper_' + chatboxtitle).remove();}, 3000);
            }
          }

          jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent").scrollTop(jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent")[0].scrollHeight);
          itemsfound += 1;
        }
      });
      //update buddy status
      jQuery.each(data.buddyStatus, function(name, status){
        if (name) {
          var chatboxalerthtml;
          if (status == 2) {
            chatboxalerthtml = '<span class="busy">' + name + ' is busy. You may be interrupting.</span>';
            jQuery("#chatbox_" + name + " .googlechat_chatboxalert").html(chatboxalerthtml);
            jQuery("#chatbox_" + name + " .chatboxtitle img").attr("class", "googlechatstatus_" + status);
          }
          else if (status == 4) {
            chatboxalerthtml = '<span class="offline">' + name + ' is offline. Messages you send will be delivered when ' + name + ' comes online.</span>';
            jQuery("#chatbox_" + name + " .googlechat_chatboxalert").html(chatboxalerthtml);
            jQuery("#chatbox_" + name + " .chatboxtitle img").attr("class", "googlechatstatus_" + status);
          }
          else {
            jQuery("#chatbox_" + name + " .googlechat_chatboxalert").html("");
            jQuery("#chatbox_" + name + " .chatboxtitle img").attr("class", "googlechatstatus_1");
          }
        }
      });
      //update buddy list
      jQuery("#googlechatbuddylist").html(data.buddylist);
      chatHeartbeatCount++;

      if (itemsfound > 0) {
        chatHeartbeatTime = minChatHeartbeat;
        chatHeartbeatCount = 1;
      } else if (chatHeartbeatCount >= 10) {
        chatHeartbeatTime *= 2;
        chatHeartbeatCount = 1;
        if (chatHeartbeatTime > maxChatHeartbeat) {
          chatHeartbeatTime = maxChatHeartbeat;
        }
      }

      setTimeout('chatHeartbeat();', chatHeartbeatTime);
    }
  });
}

function closeChatBox(chatboxtitle) {
  jQuery('#chatbox_' + chatboxtitle).css('display','none');
  restructureChatBoxes();

  jQuery.post(Drupal.settings.googlechat.closeChatUrl, {
    chatbox: chatboxtitle
  } , function(data){
    });

}

function toggleChatBoxGrowth(chatboxtitle) {
  if (jQuery('#chatbox_' + chatboxtitle + ' .chatboxcontent').css('display') == 'none') {

    var minimizedChatBoxes = new Array();

    if (jQuery.cookie('chatbox_minimized')) {
      minimizedChatBoxes = jQuery.cookie('chatbox_minimized').split(/\|/);
    }

    var newCookie = '';

    for (i = 0; i < minimizedChatBoxes.length; i++) {
      if (minimizedChatBoxes[i] != chatboxtitle) {
        newCookie += chatboxtitle + '|';
      }
    }

    newCookie = newCookie.slice(0, -1)
    jQuery.cookie('chatbox_minimized', newCookie);
    jQuery('#chatbox_' + chatboxtitle + ' .chatboxcontent').css('display','block');
    jQuery('#chatbox_' + chatboxtitle + ' .chatboxinput').css('display','block');
    jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent").scrollTop(jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent")[0].scrollHeight);
  } else {

    var newCookie = chatboxtitle;

    if (jQuery.cookie('chatbox_minimized')) {
      newCookie += '|' + jQuery.cookie('chatbox_minimized');
    }

    jQuery.cookie('chatbox_minimized',newCookie);
    jQuery('#chatbox_' + chatboxtitle + ' .chatboxcontent').css('display','none');
    jQuery('#chatbox_' + chatboxtitle + ' .chatboxinput').css('display','none');
  }

}

function checkChatBoxInputKey(event,chatboxtextarea,chatboxtitle) {
  var smileSelecterIndex;
  if(event.keyCode == 13 && event.shiftKey == 0)  {
    message = jQuery(chatboxtextarea).val();
    message = message.replace(/^\s+|\s+jQuery/g,"");

    smileSelecterIndex = jQuery('.chatboxtextareaselected').parent().children().find('li.J-KX-KU-KO').index();

    jQuery(chatboxtextarea).val('');
    jQuery(chatboxtextarea).focus();
    jQuery(chatboxtextarea).css('height','44px');
    if (message != '') {
      message = gEmotions(smileSelecterIndex, message);
      message = message.replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\"/g,"&quot;");
      jQuery.post(Drupal.settings.googlechat.sendChatUrl, {
        to: chatboxtitle,
        message: message
      } , function(data){
        message = data.items[0].m.replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&quot;/g,"\"");
        jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent").append('<div class="chatboxmessage"><div class="chatboxuserimage"><img src="' + data.items[0].p + '" alt="' + data.items[0].f + '" width="30"/></div><div class="chatboxusercontent"><span class="chatboxmessagefrom">' + data.items[0].f + ':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">' + message + '</span></div></div>');
        jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent").scrollTop(jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent")[0].scrollHeight);
      });
    }
    chatHeartbeatTime = minChatHeartbeat;
    chatHeartbeatCount = 1;

    return false;
  }

  var adjustedHeight = chatboxtextarea.clientHeight;
  var maxHeight = 94;

  if (maxHeight > adjustedHeight) {
    adjustedHeight = Math.max(chatboxtextarea.scrollHeight, adjustedHeight);
    if (maxHeight) {
      adjustedHeight = Math.min(maxHeight, adjustedHeight);
    }
    if (adjustedHeight > chatboxtextarea.clientHeight) {
      jQuery(chatboxtextarea).css('height', adjustedHeight + 8 + 'px');
    }
  } else {
    jQuery(chatboxtextarea).css('overflow','auto');
  }
}

function startChatSession(){
  jQuery.getJSON(Drupal.settings.googlechat.startChatSessionUrl, function(data) {

  username = data.username;
  jQuery.each(data.items, function(i, item) {
    if (item != '{' && item != '}' && item.f != '')	{ /* fix strange ie bug*/

      chatboxtitle = item.f;
      if (jQuery("#chatbox_" + chatboxtitle).length <= 0) {
        createChatBox(chatboxtitle, 1);
      }

      if (item.s == 1) {
        item.f = username;
      }
      msg = item.m.replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&quot;/g,"\"");
      if (item.s == 2) {
        jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent").append('<div class="chatboxmessage"><span class="chatboxinfo">' + msg + '</span></div>');
      } else {
        jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent").append('<div class="chatboxmessage"><div class="chatboxuserimage"><img src="' + item.p + '" alt="' + item.f + '" width="30"/></div><div class="chatboxusercontent"><span class="chatboxmessagefrom">' + item.f + ':&nbsp;&nbsp;</span><span class="chatboxmessagecontent">' + msg + '</span></div></div>');
      }
    }
  });

  for (i = 0; i < chatBoxes.length; i++) {
    chatboxtitle = chatBoxes[i];
    jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent").scrollTop(jQuery("#chatbox_" + chatboxtitle + " .chatboxcontent")[0].scrollHeight);
    setTimeout('jQuery("#chatbox_"+chatboxtitle+" .chatboxcontent").scrollTop(jQuery("#chatbox_"+chatboxtitle+" .chatboxcontent")[0].scrollHeight);', 100); /* yet another strange ie bug*/
  }
  setTimeout('chatHeartbeat();', chatHeartbeatTime);

  });
}

jQuery.cookie = function(name, value, options) {
  if (typeof value != 'undefined') { /* name and value given, set cookie*/
    options = options || {};
    if (value === null) {
      value = '';
      options.expires = -1;
    }
    var expires = '';
    if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
      var date;
      if (typeof options.expires == 'number') {
        date = new Date();
        date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
      } else {
        date = options.expires;
      }
      expires = '; expires=' + date.toUTCString(); /* use expires attribute, max-age is not supported by IE*/
    }
    // CAUTION: Needed to parenthesize options.path and options.domain
    // in the following expressions, otherwise they evaluate to undefined
    // in the packed version for some reason...
    var path = options.path ? '; path=' + (options.path) : '';
    var domain = options.domain ? '; domain=' + (options.domain) : '';
    var secure = options.secure ? '; secure' : '';
    document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
  } else { /* only name given, get cookie*/
    var cookieValue = null;
    if (document.cookie && document.cookie != '') {
      var cookies = document.cookie.split(';');
      for (var i = 0; i < cookies.length; i++) {
        var cookie = jQuery.trim(cookies[i]);
        // Does this cookie string begin with the name we want?
        if (cookie.substring(0, name.length + 1) == (name + '=')) {
          cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
          break;
        }
      }
    }
    return cookieValue;
  }
};

function gEmotions(smileSelecterIndex, message) {
  var classicSmilies = {
          ":)"  : "k7", ":D"  : "j6", ";)"  : "lv", ":'(" : "jj", ":-o" : "kZ", ":-/" : "k3",
          "x-(" : "i0", ":("  : "j2", "B-)" : "jf", ":P"  : "lr", "<3"  : "ka", ":-|" : "lb"
      };
  var roundSmilies = {
          ":)"  : "k9", ":D"  : "j8", ";)"  : "lx", ":'(" : "jl", ":-o" : "k1", ":-/" : "k5",
          "x-(" : "i2", ":("  : "j4", "B-)" : "jh", ":P"  : "lt", "<3"  : "kc", ":-|" : "ld"
      };
  var squareSmilies = {
          ":)"  : "k8", ":D"  : "j7", ";)"  : "lw", ":'(" : "jk", ":-o" : "k0", ":-/" : "k4",
          "x-(" : "i1", ":("  : "j3", "B-)" : "jg", ":P"  : "ls", "<3"  : "kb", ":-|" : "lc"
     };
  var mixColorSmilies = {
          ":)"  : "k6", ":D"  : "j5", ";)"  : "lu", ":'(" : "ji", ":-o" : "kY", ":-/" : "k2",
          "x-(" : "iZ", ":("  : "j1", "B-)" : "je", ":P"  : "lq", "<3"  : "j9", ":-|" : "la"
     };
  var smiles = {0 :classicSmilies, 1 : roundSmilies, 2 : squareSmilies, 3 : mixColorSmilies};
  var selectedSmileSet;
  selectedSmileSet = smiles[smileSelecterIndex];
  message = escape(message);
  for (var val in selectedSmileSet) {
    tag = '<img style="left:0px;" alt="" src="' + Drupal.settings.googlechat.emoticonsURL + '" class="' + selectedSmileSet[val] + '"></img>';
    message = message.replace(new RegExp(escape(val), "g"), tag);
  }
  message = unescape(message);
  return message;
}
